pub use dto::AdminApp;
pub use dto::AdminModel;

mod auth {

    struct AdminUser {}

    struct AdminRole {}

    struct AdminGroup {}

    struct AdminActionLog {}
}

mod dto {
    use serde::{Deserialize, Serialize};

    #[derive(Deserialize, Serialize)]
    pub struct AdminModel {
        pub key: String,
        pub name: String,

        pub admin_url: String,
        pub view_only: bool,

        pub add_url: Option<String>,
    }

    impl AdminModel {
        pub fn object_name(&self) -> &'static str {
            "hi there"
        }
    }

    #[derive(Deserialize, Serialize)]
    pub struct AdminApp {
        pub key: String,
        pub name: String,

        pub app_url: String,
        pub models: Vec<AdminModel>,
    }

    impl AdminApp {
        pub fn app_label(&self) -> &'static str {
            "gogo"
        }
    }
}
